package juliac.generated;

import org.objectweb.fractal.julia.control.lifecycle.ChainedIllegalLifeCycleException;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.julia.ComponentInterface;
import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.loader.Generated;
import org.objectweb.fractal.koch.control.interceptor.IllegalInterceptorException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.julia.Interceptor;
import org.objectweb.fractal.koch.control.interceptor.InterceptorController;
import org.objectweb.fractal.koch.control.interceptor.InterceptorDefAttributes;
import org.objectweb.fractal.api.control.LifeCycleController;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.objectweb.fractal.julia.UseComponentMixin
 * @see org.objectweb.fractal.koch.control.interceptor.InterceptorControllerMixin
 * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin
 * @see org.objectweb.fractal.koch.control.interceptor.LifeCycleInterceptorMixin
 */
public class InterceptorControllerImpl implements Controller , Generated , InterceptorController , InterceptorDefAttributes {
    /** 
     * @see org.objectweb.fractal.koch.control.interceptor.InterceptorControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(InitializationContext ic) throws InstantiationException {
        initFcController$1(ic);
    }
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableC
     */
    public Component weaveableC;
    
    /** 
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$2(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin#weaveableOptLC
     */
    public LifeCycleController weaveableOptLC;
    
    /** 
     * @see org.objectweb.fractal.koch.control.interceptor.LifeCycleInterceptorMixin#addFcInterceptor(org.objectweb.fractal.julia.ComponentInterface,org.objectweb.fractal.julia.Interceptor)
     */
    public void addFcInterceptor(ComponentInterface itf, Interceptor interceptor) throws IllegalLifeCycleException, IllegalInterceptorException {
        if ((weaveableOptLC) != null) {
            String state = weaveableOptLC.getFcState();
            if (!(LifeCycleController.STOPPED.equals(state))) {
                throw new ChainedIllegalLifeCycleException(null , weaveableOptC , "The component is not stopped");
            } 
        } 
        addFcInterceptor$0(itf ,interceptor);
    }
    
    /** 
     * @see org.objectweb.fractal.koch.control.interceptor.InterceptorControllerMixin#addFcInterceptor(org.objectweb.fractal.julia.ComponentInterface,org.objectweb.fractal.julia.Interceptor)
     */
    private void addFcInterceptor$0(ComponentInterface itf, Interceptor interceptor) {
        Object last = null;
        Object next = itf.getFcItfImpl();
        while (next instanceof Interceptor) {
            Interceptor i = ((Interceptor)(next));
            last = next;
            next = i.getFcItfDelegate();
        }
        if (last == null) {
            Object content = itf.getFcItfImpl();
            interceptor.setFcItfDelegate(content);
            itf.setFcItfImpl(interceptor);
        } else {
            Interceptor i = ((Interceptor)(last));
            Object content = i.getFcItfDelegate();
            interceptor.setFcItfDelegate(content);
            i.setFcItfDelegate(interceptor);
        }
        itf.updateFcState();
    }
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableOptC
     */
    public Component weaveableOptC;
    
    /** 
     * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(final InitializationContext ic) throws InstantiationException {
        weaveableOptLC = ((LifeCycleController)(ic.getOptionalInterface("lifecycle-controller")));
        initFcController$0(ic);
    }
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$1(final InitializationContext ic) throws InstantiationException {
        weaveableC = ((Component)(ic.getInterface("component")));
        weaveableOptC = weaveableC;
        initFcController$2(ic);
    }
    
    /** 
     * @see org.objectweb.fractal.koch.control.interceptor.LifeCycleInterceptorMixin#removeFcInterceptor(org.objectweb.fractal.julia.ComponentInterface,org.objectweb.fractal.julia.Interceptor)
     */
    public boolean removeFcInterceptor(ComponentInterface itf, Interceptor interceptor) throws IllegalLifeCycleException, IllegalInterceptorException {
        if ((weaveableOptLC) != null) {
            String state = weaveableOptLC.getFcState();
            if (!(LifeCycleController.STOPPED.equals(state))) {
                throw new ChainedIllegalLifeCycleException(null , weaveableOptC , "The component is not stopped");
            } 
        } 
        return removeFcInterceptor$0(itf ,interceptor);
    }
    
    private void initFcController$3(InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.objectweb.fractal.koch.control.interceptor.InterceptorControllerMixin#getFcInterceptors(org.objectweb.fractal.julia.ComponentInterface)
     */
    public Interceptor[] getFcInterceptors(ComponentInterface itf) {
        Object next = itf.getFcItfImpl();
        int size = 0;
        while (next instanceof Interceptor) {
            Interceptor i = ((Interceptor)(next));
            next = i.getFcItfDelegate();
            size++;
        }
        Interceptor[] result = new Interceptor[size];
        next = itf.getFcItfImpl();
        size = 0;
        while (next instanceof Interceptor) {
            Interceptor i = ((Interceptor)(next));
            result[size] = i;
            next = i.getFcItfDelegate();
            size++;
        }
        return result;
    }
    
    private void addFcInterceptor$1(ComponentInterface itf, Interceptor interceptor) throws IllegalLifeCycleException, IllegalInterceptorException {
    }
    
    /** 
     * @see org.objectweb.fractal.koch.control.interceptor.InterceptorControllerMixin#removeFcInterceptor(org.objectweb.fractal.julia.ComponentInterface,org.objectweb.fractal.julia.Interceptor)
     */
    private boolean removeFcInterceptor$0(ComponentInterface itf, Interceptor interceptor) {
        Object previous = null;
        Object next = itf.getFcItfImpl();
        while (next instanceof Interceptor) {
            Interceptor i = ((Interceptor)(next));
            if (next == interceptor) {
                Object nextnext = i.getFcItfDelegate();
                if (previous == null) {
                    itf.setFcItfImpl(nextnext);
                } else {
                    Interceptor p = ((Interceptor)(previous));
                    p.setFcItfDelegate(nextnext);
                }
                itf.updateFcState();
                return true;
            } 
            previous = next;
            next = i.getFcItfDelegate();
        }
        return false;
    }
    
    private boolean removeFcInterceptor$1(ComponentInterface itf, Interceptor interceptor) throws IllegalLifeCycleException, IllegalInterceptorException {
        return false;
    }
    
    /** 
     * @see org.objectweb.fractal.koch.control.interceptor.InterceptorControllerMixin#setInterceptors(java.lang.String)
     */
    public void setInterceptors(String interceptors) {
        this.interceptors = interceptors;
    }
    
    /** 
     * @see org.objectweb.fractal.koch.control.interceptor.InterceptorControllerMixin#getInterceptors()
     */
    public String getInterceptors() {
        return interceptors;
    }
    
    /** 
     * @see org.objectweb.fractal.koch.control.interceptor.InterceptorControllerMixin#interceptors
     */
    private String interceptors = "";
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator juliac.generated.InterceptorControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.objectweb.fractal.julia.UseComponentMixin org.objectweb.fractal.koch.control.interceptor.InterceptorControllerMixin org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin org.objectweb.fractal.koch.control.interceptor.LifeCycleInterceptorMixin)";
    }
    
}

